/* bf.h
 *
 * definitions for the optimizing brainfuck compiler
 *
 * Copyright (C) 2004 Manuel Schiller
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _BF_H
#define _BF_H

#define OBFC_VERSION	"0.0.1"

/* intermediate instruction type */
typedef enum {
	ADDI,	/* add/subtract immediate value to/from *p */
	PTRI,	/* move pointer p  by immediate value */
	ADD,	/* this may be generated during loop elimination */
	ZERO,	/* this may be generated during loop elimination */
	LOOP,	/* while (*p) { */
	POOL,	/* } */
	IN,	/* read data */
	OUT,	/* write data */
	EOP	/* end of program */
} bfitype_t;

/* brainfuck instruction
 * NOTE: some optimization is done right away when parsing... */
typedef struct {
	bfitype_t instr;
	/* the attr field contains how much to add or how far to move the
	 * pointer etc. */
	long attr;
	/* the attr2 field contains how much to multiply the value at the
	 * current pointer by in an ADD instruction */
	long attr2;
} bfinstr_t;

#endif /* _BF_H */
